"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _constants = require("./constants");

var _SwipeButtonCircle = require("./SwipeButtonCircle");

var _SwipeButtonText = _interopRequireDefault(require("./SwipeButtonText"));

var _SwipeGradient = _interopRequireWildcard(require("./SwipeGradient"));

var _SwipeButtonUnderlayText = _interopRequireDefault(require("./SwipeButtonUnderlayText"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const SwipeButton = _ref => {
  let {
    title,
    titleContainerExtraViewProps,
    titleExtraTextProps,
    titleContainerStyle,
    titleStyle,
    underlayStyle,
    disabled,
    Icon,
    containerStyle,
    circleBackgroundColor,
    underlayContainerGradientProps,
    containerGradientProps,
    iconContainerStyle,
    titleElement,
    underlayTitleElement,
    underlayTitle,
    underlayTitleExtraTextProps,
    underlayTitleStyle,
    underlayTitleContainerExtraViewProps,
    underlayTitleContainerStyle,
    onComplete,
    onSwipeProgress = _progress => {},
    onSwipeEnd = () => {},
    onSwipeStart = () => {},
    circleSize = _constants.DEFAULT_HEIGHT,
    height = _constants.DEFAULT_HEIGHT,
    width = _constants.DEFAULT_WIDTH,
    borderRadius = _constants.DEFAULT_BORDER_RADIUS,
    completeThresholdPercentage = _constants.DEFAULT_COMPLETE_THRESHOLD_PERCENTAGE,
    goBackToStart = _constants.DEFAULT_GO_BACK_TO_START
  } = _ref;
  const [endReached, setEndReached] = (0, _react.useState)(false);
  const opacity = disabled ? 0.5 : 1;
  const opacityStyle = {
    opacity
  };
  const [translateX] = (0, _react.useState)(new _reactNative.Animated.Value(0));
  const scrollDistance = width - completeThresholdPercentage / 100 - circleSize;
  const completeThreshold = scrollDistance * (completeThresholdPercentage / 100);

  const animateToStart = () => {
    _reactNative.Animated.spring(translateX, {
      toValue: 0,
      tension: 10,
      friction: 5,
      useNativeDriver: false
    }).start();

    return setEndReached(false);
  };

  const animateToEnd = () => {
    onComplete();

    _reactNative.Animated.spring(translateX, {
      toValue: scrollDistance,
      tension: 10,
      friction: 5,
      useNativeDriver: false
    }).start();

    _reactNative.Animated.spring(translateX, {
      toValue: scrollDistance,
      tension: 10,
      friction: 5,
      useNativeDriver: false
    }).start();

    if (goBackToStart) {
      setEndReached(true);
      return animateToStart();
    }

    return setEndReached(true);
  };

  const onMove = (_, gestureState) => {
    if (gestureState.dx > 0) {
      onSwipeProgress(gestureState.dx);
    }

    if (disabled) {
      return false;
    }

    if (gestureState.dx < 0 || gestureState.dx > scrollDistance) {
      return _reactNative.Animated.event([{
        dx: translateX
      }], {
        useNativeDriver: false
      })({ ...gestureState,
        dx: gestureState.dx < 0 ? 0 : scrollDistance
      });
    }

    return _reactNative.Animated.event([{
      dx: translateX
    }], {
      useNativeDriver: false
    })(gestureState);
  };

  const onRelease = () => {
    if (disabled) {
      return;
    }

    if (endReached) {
      return animateToStart();
    }

    const isCompleted = translateX._value >= completeThreshold;
    return isCompleted ? animateToEnd() : animateToStart();
  };

  const panResponser = () => _reactNative.PanResponder.create({
    onPanResponderGrant: onSwipeStart,
    onPanResponderEnd: onSwipeEnd,
    onStartShouldSetPanResponder: () => false,
    onMoveShouldSetPanResponder: () => true,
    onMoveShouldSetPanResponderCapture: () => false,
    onPanResponderMove: onMove,
    onPanResponderRelease: onRelease
  });

  return /*#__PURE__*/_react.default.createElement(_SwipeGradient.default, _extends({}, containerGradientProps, {
    style: [styles.container, opacityStyle, containerStyle, {
      height,
      width,
      borderRadius
    }]
  }), /*#__PURE__*/_react.default.createElement(_SwipeButtonText.default, {
    title: title,
    titleStyle: titleStyle,
    titleExtraTextProps: titleExtraTextProps,
    height: height,
    titleContainerExtraViewProps: titleContainerExtraViewProps,
    titleContainerStyle: titleContainerStyle,
    titleElement: titleElement
  }), !disabled && /*#__PURE__*/_react.default.createElement(_SwipeGradient.AnimatedGradient, _extends({
    testID: "Underlay",
    style: [styles.underlayContainer, underlayStyle, {
      width: translateX.interpolate({
        inputRange: [0, 100],
        outputRange: [60, 160]
      }),
      height
    }]
  }, underlayContainerGradientProps), underlayTitle && /*#__PURE__*/_react.default.createElement(_SwipeButtonUnderlayText.default, {
    underlayTitle: underlayTitle,
    underlayTitleStyle: underlayTitleStyle,
    underlayTitleExtraTextProps: underlayTitleExtraTextProps,
    height: height,
    underlayTitleContainerExtraViewProps: underlayTitleContainerExtraViewProps,
    underlayTitleContainerStyle: underlayTitleContainerStyle,
    underlayTitleElement: underlayTitleElement,
    animation: translateX
  })), /*#__PURE__*/_react.default.createElement(_SwipeButtonCircle.SwipeButtonCircle, {
    circleBackgroundColor: circleBackgroundColor,
    Icon: Icon,
    opacity: opacity,
    panHandlers: panResponser().panHandlers,
    translateX: translateX,
    borderRadius: borderRadius,
    circleSize: circleSize,
    iconContainerStyle: iconContainerStyle
  }));
};

var _default = SwipeButton;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {
    backgroundColor: 'white',
    alignSelf: 'center',
    justifyContent: 'center',
    marginVertical: 10
  },
  underlayContainer: {
    position: 'absolute',
    backgroundColor: '#152228',
    borderTopStartRadius: _constants.DEFAULT_BORDER_RADIUS,
    borderBottomStartRadius: _constants.DEFAULT_BORDER_RADIUS,
    borderBottomEndRadius: _constants.DEFAULT_BORDER_RADIUS,
    borderTopEndRadius: _constants.DEFAULT_BORDER_RADIUS
  }
});
//# sourceMappingURL=SwipeButton.js.map