"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SwipeButtonCircle = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const SwipeButtonCircle = _ref => {
  let {
    Icon,
    opacity,
    panHandlers,
    translateX,
    circleSize,
    borderRadius,
    circleBackgroundColor,
    iconContainerStyle
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, _extends({
    testID: "Button"
  }, panHandlers, {
    style: [styles.iconContainer, iconContainerStyle, {
      opacity,
      width: circleSize,
      height: circleSize,
      borderRadius,
      transform: [{
        translateX
      }]
    }]
  }), /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    testID: "IconContainer",
    style: [styles.innerIconContainer, {
      backgroundColor: circleBackgroundColor,
      width: circleSize,
      height: circleSize,
      borderRadius
    }, {
      opacity
    }]
  }, Icon));
};

exports.SwipeButtonCircle = SwipeButtonCircle;

const styles = _reactNative.StyleSheet.create({
  iconContainer: {
    position: 'absolute',
    backgroundColor: 'black',
    alignItems: 'center',
    justifyContent: 'center'
  },
  innerIconContainer: {
    alignItems: 'center',
    justifyContent: 'center'
  }
});
//# sourceMappingURL=SwipeButtonCircle.js.map