"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.AnimatedGradient = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

var _expoLinearGradient = require("expo-linear-gradient");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class SwipeGradientView extends _react.default.Component {
  render() {
    const {
      style,
      children,
      colors,
      start,
      end,
      locations
    } = this.props;

    if (colors) {
      if (!children) {
        return /*#__PURE__*/_react.default.createElement(_expoLinearGradient.LinearGradient, {
          colors: colors,
          end: end,
          locations: locations,
          start: start,
          style: style
        });
      }

      return /*#__PURE__*/_react.default.createElement(_expoLinearGradient.LinearGradient, {
        colors: colors,
        end: end,
        locations: locations,
        start: start,
        style: style
      }, children);
    }

    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: style
    }, children);
  }

}

var _default = SwipeGradientView;
exports.default = _default;

const AnimatedGradient = _reactNative.Animated.createAnimatedComponent(SwipeGradientView);

exports.AnimatedGradient = AnimatedGradient;
//# sourceMappingURL=SwipeGradient.js.map