import React from 'react';
import { Animated, View } from 'react-native';
import { LinearGradient } from 'expo-linear-gradient';

class SwipeGradientView extends React.Component {
  render() {
    const {
      style,
      children,
      colors,
      start,
      end,
      locations
    } = this.props;

    if (colors) {
      if (!children) {
        return /*#__PURE__*/React.createElement(LinearGradient, {
          colors: colors,
          end: end,
          locations: locations,
          start: start,
          style: style
        });
      }

      return /*#__PURE__*/React.createElement(LinearGradient, {
        colors: colors,
        end: end,
        locations: locations,
        start: start,
        style: style
      }, children);
    }

    return /*#__PURE__*/React.createElement(View, {
      style: style
    }, children);
  }

}

export default SwipeGradientView;
export const AnimatedGradient = Animated.createAnimatedComponent(SwipeGradientView);
//# sourceMappingURL=SwipeGradient.js.map