import { FC } from 'react';
import { TextProps, StyleProp, TextStyle, ViewProps, ViewStyle } from 'react-native';
export interface SwipeButtonTextProps {
    /**
     * The text that will be displayed in the container
     */
    title: string;
    /**
     * Additional props for the title text
     */
    titleExtraTextProps?: TextProps;
    /**
     * Additional styling for the title text
     */
    titleStyle?: StyleProp<TextStyle>;
    /**
     * Additional props for the title container
     */
    titleContainerExtraViewProps?: ViewProps;
    /**
     * Additional styling for the title container
     */
    titleContainerStyle?: StyleProp<ViewStyle>;
    /**
     * Height of the title container
     */
    height?: number;
    /**
     * An JSX element you can define to replace the title default component. Using this will omit the others title props
     */
    titleElement?: JSX.Element;
}
declare const SwipeButtonText: FC<SwipeButtonTextProps>;
export default SwipeButtonText;
