import { FC } from 'react';
import { TextProps, StyleProp, TextStyle, ViewProps, ViewStyle, Animated } from 'react-native';
export interface SwipeButtonUnderlayTextProps {
    /**
     * The text that will be displayed in the underlay container
     */
    underlayTitle?: string;
    /**
     * Additional props for the underlay title text
     */
    underlayTitleExtraTextProps?: TextProps;
    /**
     * Additional styling for the underlay title text
     */
    underlayTitleStyle?: StyleProp<TextStyle>;
    /**
     * Additional props for the underlay title container
     */
    underlayTitleContainerExtraViewProps?: ViewProps;
    /**
     * Additional styling for the underlay title container
     */
    underlayTitleContainerStyle?: StyleProp<ViewStyle>;
    /**
     * Height of the underlay title container
     */
    height?: number;
    /**
     * An JSX element you can define to replace the underlay title default component. Using this will omit the others title props
     */
    underlayTitleElement?: JSX.Element;
}
interface PrivateProps {
    animation?: Animated.Value;
}
declare const SwipeButtonUnderlayText: FC<SwipeButtonUnderlayTextProps & PrivateProps>;
export default SwipeButtonUnderlayText;
